/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief UARTײ
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: ATmega32U4
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2007, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#ifndef _UART_DRV_H_
#define _UART_DRV_H_

#define MSK_UART_5BIT			0x00	/* UCSRnCڼ޽ */
#define MSK_UART_6BIT			0x02
#define MSK_UART_7BIT			0x04
#define MSK_UART_8BIT			0x06
#define MSK_UART_9BIT			0x06

#define MSK_UART_RX_DONE		0x80	/* UCSRnAڼ޽ */
#define MSK_UART_TX_COMPLET		0x40
#define MSK_UART_DRE			0x20

#define MSK_UART_ENABLE_IT_RX	0x80
#define MSK_UART_ENABLE_IT_TX	0x40
#define MSK_UART_ENABLE_RX		0x10	/* UCSRnBڼ޽ */
#define MSK_UART_ENABLE_TX		0x08
#define MSK_UART_TX_BIT9		0x01
#define MSK_UART_RX_BIT9		0x02

#ifdef USE_UART1
  #define UCSRC					(UCSR0C)
  #define UCSRB					(UCSR0B)
  #define UCSRA					(UCSR0A)
  #define UDR					(UDR0)
  #define UBRRL					(UBRR0L)
  #define UBRRH					(UBRR0H)
  #define UBRR					(UBRR0)
#endif
#ifdef USE_UART2
  #define UCSRC					(UCSR1C)
  #define UCSRB					(UCSR1B)
  #define UCSRA					(UCSR1A)
  #define UDR					(UDR1)
  #define UBRRL					(UBRR1L)
  #define UBRRH					(UBRR1H)
  #define UBRR					(UBRR1)
#endif

#define Uart_hw_init(config)	(UCSRC=config)
#define Uart_enable()			(UCSRB|=MSK_UART_ENABLE_RX|MSK_UART_ENABLE_TX)
#define Uart_tx_ready()			(UCSRA&MSK_UART_DRE)
#define Uart_set_tx_busy()
#define Uart_send_byte(ch)		(UDR=ch)
#define Uart_rx_ready()			(UCSRA&MSK_UART_RX_DONE)
#define Uart_get_byte()			(UDR)
#define Uart_ack_rx_byte()

#define Uart_enable_it_rx()		(UCSRB|=MSK_UART_ENABLE_IT_RX)
#define Uart_enable_it_tx()		(UCSRB|=MSK_UART_ENABLE_IT_TX)
#define Uart_disable_it_rx()	(UCSRB&=~MSK_UART_ENABLE_IT_RX)

#endif
